#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_NewPlayerQuestCFG.h"
std::auto_ptr<M_NewPlayerQuestCFG> M_NewPlayerQuestCFG::msSingleton(nullptr);

int M_NewPlayerQuestCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_NewPlayerQuestCFGData* M_NewPlayerQuestCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_NewPlayerQuestCFGData>& M_NewPlayerQuestCFG::GetMapData()
{
	return mMapData;
}

void M_NewPlayerQuestCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_NewPlayerQuestCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_NewPlayerQuestCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mDesc = element->Attribute("Desc");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mResources = element->Attribute("Resources");
		data.mNextQuestID = element->IntAttribute("NextQuestID");
		data.mScale = element->IntAttribute("Scale");
		data.mDefault = element->IntAttribute("Default");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mTelephoneBill = element->IntAttribute("TelephoneBill");
		data.mTaskIcon = element->Attribute("TaskIcon");
		data.mRewardIcon = element->Attribute("RewardIcon");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_NewPlayerQuestCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NewPlayerQuestCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_NewPlayerQuestCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_NewPlayerQuestCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_NewPlayerQuestCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readString(L, "Resources", data.mResources);
		LuaCfgHelper::readInt(L, "NextQuestID", data.mNextQuestID);
		LuaCfgHelper::readInt(L, "Scale", data.mScale);
		LuaCfgHelper::readInt(L, "Default", data.mDefault);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "TelephoneBill", data.mTelephoneBill);
		LuaCfgHelper::readString(L, "TaskIcon", data.mTaskIcon);
		LuaCfgHelper::readString(L, "RewardIcon", data.mRewardIcon);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_NewPlayerQuestCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NewPlayerQuestCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_NewPlayerQuestCFG* M_NewPlayerQuestCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_NewPlayerQuestCFG());
	}
	return msSingleton.get();
}

void M_NewPlayerQuestCFG::Release()
{
	msSingleton.reset(nullptr);
}
